diff --git a/src/main/java/net/minecraft/core/block/BlockLeavesShrub.java b/src/main/java/net/minecraft/core/block/BlockLeavesShrub.java
index a15cfa626..7dcb14aea 100644
--- a/src/main/java/net/minecraft/core/block/BlockLeavesShrub.java
+++ b/src/main/java/net/minecraft/core/block/BlockLeavesShrub.java
@@ -28,7 +28,7 @@ public class BlockLeavesShrub extends BlockLeavesBase
     @Override
 	public void randomDisplayTick(World world, int x, int y, int z, Random rand)
     {
-        if (world.seasonManager.getCurrentSeason() != null && world.seasonManager.getCurrentSeason().hasFallingLeaves && rand.nextInt(40) == 0)
+        if (world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().hasFallingLeaves && rand.nextInt(40) == 0)
         {
             world.spawnParticle("fallingleaf", x, (double) y - 0.1f, z, 0, 0, 0);
         }
diff --git a/src/main/java/net/minecraft/core/block/BlockLever.java b/src/main/java/net/minecraft/core/block/BlockLever.java
index c28f8c9a0..7333aa2eb 100644
--- a/src/main/java/net/minecraft/core/block/BlockLever.java
+++ b/src/main/java/net/minecraft/core/block/BlockLever.java
@@ -24,7 +24,7 @@ public class BlockLever extends Block
     }
 
     @Override
-	public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z)
+	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         return null;
     }
@@ -176,7 +176,7 @@ public class BlockLever extends Block
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(World world, int x, int y, int z)
+    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
         int l = world.getBlockMetadata(x, y, z) & 7;
         float f = 0.1875F;
diff --git a/src/main/java/net/minecraft/core/block/BlockOverlayPebbles.java b/src/main/java/net/minecraft/core/block/BlockOverlayPebbles.java
index 9b74079d6..61fdb3b3b 100644
--- a/src/main/java/net/minecraft/core/block/BlockOverlayPebbles.java
+++ b/src/main/java/net/minecraft/core/block/BlockOverlayPebbles.java
@@ -7,6 +7,7 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 
 public class BlockOverlayPebbles extends Block
 {
@@ -35,13 +36,13 @@ public class BlockOverlayPebbles extends Block
     }
 
     @Override
-    public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z)
+    public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         return null;
     }
 
     @Override
-    public AABB getSelectedBoundingBoxFromPool(World world, int x, int y, int z)
+    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         return AABB.getBoundingBoxFromPool(x, y, z, x + 1, y + 0.0625f, z + 1);
     }
@@ -57,7 +58,7 @@ public class BlockOverlayPebbles extends Block
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(World world, int x, int y, int z)
+    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
         minX = 0;
         minY = 0;
diff --git a/src/main/java/net/minecraft/core/block/BlockPortal.java b/src/main/java/net/minecraft/core/block/BlockPortal.java
index 00a0a7040..419585e3c 100644
--- a/src/main/java/net/minecraft/core/block/BlockPortal.java
+++ b/src/main/java/net/minecraft/core/block/BlockPortal.java
@@ -8,6 +8,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 
 import java.util.Random;
 
@@ -31,13 +32,13 @@ public class BlockPortal extends BlockTransparent
    
 
     @Override
-	public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z)
+	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         return null;
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(World world, int x, int y, int z)
+    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
         int meta = world.getBlockMetadata(x, y, z);
         if((meta & 0x1) > 0)
diff --git a/src/main/java/net/minecraft/core/block/BlockPressurePlate.java b/src/main/java/net/minecraft/core/block/BlockPressurePlate.java
index d7524bc80..f3f4e851a 100644
--- a/src/main/java/net/minecraft/core/block/BlockPressurePlate.java
+++ b/src/main/java/net/minecraft/core/block/BlockPressurePlate.java
@@ -8,10 +8,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.world.World;
-import net.minecraft.core.world.WorldSource;
 
 import java.util.List;
 import java.util.Random;
@@ -36,7 +33,7 @@ public class BlockPressurePlate extends Block
     }
 
     @Override
-	public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z)
+	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         return null;
     }
@@ -141,7 +138,7 @@ public class BlockPressurePlate extends Block
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(World world, int x, int y, int z)
+    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
         int meta = world.getBlockMetadata(x, y, z);
         boolean isPressed = isPressed(meta);
diff --git a/src/main/java/net/minecraft/core/block/BlockRail.java b/src/main/java/net/minecraft/core/block/BlockRail.java
index d3f9ba55c..94302ff9a 100644
--- a/src/main/java/net/minecraft/core/block/BlockRail.java
+++ b/src/main/java/net/minecraft/core/block/BlockRail.java
@@ -7,6 +7,7 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.Vec3d;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 
 import java.util.Random;
 
@@ -41,7 +42,7 @@ public class BlockRail extends Block
     }
 
     @Override
-	public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z)
+	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         return null;
     }
@@ -60,7 +61,7 @@ public class BlockRail extends Block
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(World world, int x, int y, int z)
+    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
         int l = world.getBlockMetadata(x, y, z);
         if(l >= 2 && l <= 5)
diff --git a/src/main/java/net/minecraft/core/block/BlockRedstoneWire.java b/src/main/java/net/minecraft/core/block/BlockRedstoneWire.java
index a9699b37c..d9f4cb344 100644
--- a/src/main/java/net/minecraft/core/block/BlockRedstoneWire.java
+++ b/src/main/java/net/minecraft/core/block/BlockRedstoneWire.java
@@ -31,7 +31,7 @@ public class BlockRedstoneWire extends Block
     }
 
     @Override
-	public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z)
+	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         return null;
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockRope.java b/src/main/java/net/minecraft/core/block/BlockRope.java
index 2459ac1d4..4867ec371 100644
--- a/src/main/java/net/minecraft/core/block/BlockRope.java
+++ b/src/main/java/net/minecraft/core/block/BlockRope.java
@@ -7,6 +7,7 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 
 public class BlockRope
     extends Block {
@@ -30,12 +31,12 @@ public class BlockRope
     }
 
     @Override
-    public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z) {
+    public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z) {
         return null;
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(World world, int x, int y, int z)
+    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
         boolean hasBlockNegX = world.getBlockId(x - 1, y, z) == this.id;
         boolean hasBlockPosX = world.getBlockId(x + 1, y, z) == this.id;
diff --git a/src/main/java/net/minecraft/core/block/BlockSaplingBase.java b/src/main/java/net/minecraft/core/block/BlockSaplingBase.java
index 34a722e10..13e0a0c1f 100644
--- a/src/main/java/net/minecraft/core/block/BlockSaplingBase.java
+++ b/src/main/java/net/minecraft/core/block/BlockSaplingBase.java
@@ -44,8 +44,8 @@ public abstract class BlockSaplingBase extends BlockFlower implements IBonemeala
 
         super.updateTick(world, x, y, z, rand);
         int growthRate = 30;
-        if(world.seasonManager.getCurrentSeason() != null){
-            growthRate = MathHelper.floor_float(growthRate / world.seasonManager.getCurrentSeason().cropGrowthFactor);
+        if(world.getSeasonManager().getCurrentSeason() != null){
+            growthRate = MathHelper.floor_float(growthRate / world.getSeasonManager().getCurrentSeason().cropGrowthFactor);
         }
         if(world.getBlockLightValue(x, y + 1, z) >= 9 && rand.nextInt(growthRate) == 0)
         {
diff --git a/src/main/java/net/minecraft/core/block/BlockSaplingOak.java b/src/main/java/net/minecraft/core/block/BlockSaplingOak.java
index ed366e8f9..d0dc98c63 100644
--- a/src/main/java/net/minecraft/core/block/BlockSaplingOak.java
+++ b/src/main/java/net/minecraft/core/block/BlockSaplingOak.java
@@ -23,8 +23,8 @@ public class BlockSaplingOak extends BlockSaplingBase
     @Override
 	public void growTree(World world, int i, int j, int k, Random random)
     {
-    	Object treeBig = new WorldFeatureTreeCaatinga(Block.leavesOak.id, Block.logOak.id);
-        Object treeSmall = new WorldFeatureTreeCaatinga(Block.leavesOak.id, Block.logOak.id);
+    	Object treeBig = new WorldFeatureTreeFancy(Block.leavesOak.id, Block.logOak.id);
+        Object treeSmall = new WorldFeatureTree(Block.leavesOak.id, Block.logOak.id, 4);
     	world.setBlock(i, j, k, 0);
 
         if(!((WorldFeature) (treeSmall)).generate(world, random, i, j, k))
diff --git a/src/main/java/net/minecraft/core/block/BlockSign.java b/src/main/java/net/minecraft/core/block/BlockSign.java
index ebd4240a1..62efa5712 100644
--- a/src/main/java/net/minecraft/core/block/BlockSign.java
+++ b/src/main/java/net/minecraft/core/block/BlockSign.java
@@ -9,6 +9,7 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.world.WorldSource;
 
 // Referenced classes of package net.minecraft.src:
 //            BlockContainer, Material, IBlockAccess, TileEntity, 
@@ -28,20 +29,20 @@ public class BlockSign extends BlockTileEntity
     }
 
     @Override
-	public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z)
+	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         return null;
     }
 
     @Override
-    public AABB getSelectedBoundingBoxFromPool(World world, int x, int y, int z)
+    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         setBlockBoundsBasedOnState(world, x, y, z);
         return super.getSelectedBoundingBoxFromPool(world, x, y, z);
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(World world, int x, int y, int z)
+    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
         if(isFreestanding)
         {
diff --git a/src/main/java/net/minecraft/core/block/BlockSlab.java b/src/main/java/net/minecraft/core/block/BlockSlab.java
index 2c36309a9..ca636d34f 100644
--- a/src/main/java/net/minecraft/core/block/BlockSlab.java
+++ b/src/main/java/net/minecraft/core/block/BlockSlab.java
@@ -38,7 +38,7 @@ public class BlockSlab extends Block
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(World world, int x, int y, int z)
+    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
         int l = world.getBlockMetadata(x, y, z) & 0x3;
         if(l == 0)
@@ -50,7 +50,7 @@ public class BlockSlab extends Block
     }
 
     @Override
-	public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z)
+	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         int l = world.getBlockMetadata(x, y, z) & 0x3;
         if(l == 0)
@@ -109,7 +109,7 @@ public class BlockSlab extends Block
     }
 
     @Override
-    public AABB getSelectedBoundingBoxFromPool(World world, int x, int y, int z)
+    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         return getCollisionBoundingBoxFromPool(world, x, y, z);
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockSoulSand.java b/src/main/java/net/minecraft/core/block/BlockSoulSand.java
index a62d694de..40419ab71 100644
--- a/src/main/java/net/minecraft/core/block/BlockSoulSand.java
+++ b/src/main/java/net/minecraft/core/block/BlockSoulSand.java
@@ -9,6 +9,7 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 
 public class BlockSoulSand extends Block
 {
@@ -19,7 +20,7 @@ public class BlockSoulSand extends Block
     }
 
     @Override
-	public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z)
+	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         float f = 0.125F;
         return AABB.getBoundingBoxFromPool(x, y, z, x + 1, (float)(y + 1) - f, z + 1);
diff --git a/src/main/java/net/minecraft/core/block/BlockSpikes.java b/src/main/java/net/minecraft/core/block/BlockSpikes.java
index 7d39736bb..ac1610170 100644
--- a/src/main/java/net/minecraft/core/block/BlockSpikes.java
+++ b/src/main/java/net/minecraft/core/block/BlockSpikes.java
@@ -11,6 +11,7 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.helper.DamageType;
+import net.minecraft.core.world.WorldSource;
 
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, Entity, Item,
@@ -66,7 +67,7 @@ public class BlockSpikes extends BlockCobweb
 	}
 
     @Override
-	public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z)
+	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {	
     	float f = 1.0f / 16.0f;
         return AABB.getBoundingBoxFromPool(x + f, y, z + f, x + 1 - f, y + 0.1875F, z + 1 - f);
diff --git a/src/main/java/net/minecraft/core/block/BlockStairs.java b/src/main/java/net/minecraft/core/block/BlockStairs.java
index 7572f8254..ea26a6f61 100644
--- a/src/main/java/net/minecraft/core/block/BlockStairs.java
+++ b/src/main/java/net/minecraft/core/block/BlockStairs.java
@@ -94,13 +94,13 @@ public class BlockStairs extends Block
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(World world, int x, int y, int z)
+    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
     }
 
     @Override
-	public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z)
+	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         return super.getCollisionBoundingBoxFromPool(world, x, y, z);
     }
@@ -217,7 +217,7 @@ public class BlockStairs extends Block
     }
 
     @Override
-    public AABB getSelectedBoundingBoxFromPool(World world, int x, int y, int z)
+    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         return modelBlock.getSelectedBoundingBoxFromPool(world, x, y, z);
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockSugarcane.java b/src/main/java/net/minecraft/core/block/BlockSugarcane.java
index 1960f42f7..a9f0517e6 100644
--- a/src/main/java/net/minecraft/core/block/BlockSugarcane.java
+++ b/src/main/java/net/minecraft/core/block/BlockSugarcane.java
@@ -11,6 +11,7 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 
 import java.util.Random;
 
@@ -118,7 +119,7 @@ public class BlockSugarcane extends Block implements IBonemealable
     }
 
     @Override
-	public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z)
+	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         return null;
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockTorch.java b/src/main/java/net/minecraft/core/block/BlockTorch.java
index e8ed69eea..089334c83 100644
--- a/src/main/java/net/minecraft/core/block/BlockTorch.java
+++ b/src/main/java/net/minecraft/core/block/BlockTorch.java
@@ -10,6 +10,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.Vec3d;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, World, AxisAlignedBB, 
@@ -25,7 +26,7 @@ public class BlockTorch extends Block
     }
 
     @Override
-	public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z)
+	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         return null;
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockTrapDoor.java b/src/main/java/net/minecraft/core/block/BlockTrapDoor.java
index 08071014c..bde3c5884 100644
--- a/src/main/java/net/minecraft/core/block/BlockTrapDoor.java
+++ b/src/main/java/net/minecraft/core/block/BlockTrapDoor.java
@@ -5,13 +5,12 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.EntityLiving;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.PlacementMode;
-import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.helper.Sides;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.Vec3d;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, IBlockAccess, World, 
@@ -45,21 +44,21 @@ public class BlockTrapDoor extends Block
     }
 
     @Override
-    public AABB getSelectedBoundingBoxFromPool(World world, int x, int y, int z)
+    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         setBlockBoundsBasedOnState(world, x, y, z);
         return super.getSelectedBoundingBoxFromPool(world, x, y, z);
     }
 
     @Override
-	public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z)
+	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         setBlockBoundsBasedOnState(world, x, y, z);
         return super.getCollisionBoundingBoxFromPool(world, x, y, z);
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(World world, int x, int y, int z)
+    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
         setBlockBoundsForBlockRender(world.getBlockMetadata(x, y, z));
     }
diff --git a/src/main/java/net/minecraft/core/block/piston/BlockPistonBase.java b/src/main/java/net/minecraft/core/block/piston/BlockPistonBase.java
index a65165aaa..935fb9fd7 100644
--- a/src/main/java/net/minecraft/core/block/piston/BlockPistonBase.java
+++ b/src/main/java/net/minecraft/core/block/piston/BlockPistonBase.java
@@ -13,6 +13,7 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 
 public class BlockPistonBase extends Block
 {
@@ -195,7 +196,7 @@ public class BlockPistonBase extends Block
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(World world, int x, int y, int z)
+    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
         int l = world.getBlockMetadata(x, y, z);
         if(isPowered(l))
diff --git a/src/main/java/net/minecraft/core/block/piston/BlockPistonHead.java b/src/main/java/net/minecraft/core/block/piston/BlockPistonHead.java
index 97232bea3..3bc54f8e0 100644
--- a/src/main/java/net/minecraft/core/block/piston/BlockPistonHead.java
+++ b/src/main/java/net/minecraft/core/block/piston/BlockPistonHead.java
@@ -11,6 +11,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.logic.PistonDirections;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 
 public class BlockPistonHead extends Block
 {
@@ -132,7 +133,7 @@ public class BlockPistonHead extends Block
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(World world, int x, int y, int z)
+    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
         int l = world.getBlockMetadata(x, y, z);
         switch(getDirectionFromMeta(l))
diff --git a/src/main/java/net/minecraft/core/block/piston/BlockPistonMoving.java b/src/main/java/net/minecraft/core/block/piston/BlockPistonMoving.java
index ace3ba522..12c175d21 100644
--- a/src/main/java/net/minecraft/core/block/piston/BlockPistonMoving.java
+++ b/src/main/java/net/minecraft/core/block/piston/BlockPistonMoving.java
@@ -122,7 +122,7 @@ public class BlockPistonMoving extends BlockTileEntity
     }
 
     @Override
-	public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z)
+	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         TileEntityPistonMoving tileEntity = getBlockEntity(world, x, y, z);
         if(tileEntity == null)
@@ -138,7 +138,7 @@ public class BlockPistonMoving extends BlockTileEntity
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(World world, int x, int y, int z)
+    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
         TileEntityPistonMoving tileentitypiston = getBlockEntity(world, x, y, z);
         if(tileentitypiston != null)
@@ -164,7 +164,7 @@ public class BlockPistonMoving extends BlockTileEntity
         }
     }
 
-    public AABB getCollisionShapeFromTileEntity(World world, int x, int y, int z, int l, float f, int i1)
+    public AABB getCollisionShapeFromTileEntity(WorldSource world, int x, int y, int z, int l, float f, int i1)
     {
         if(l == 0 || l == id)
         {
diff --git a/src/main/java/net/minecraft/core/entity/animal/EntityAnimal.java b/src/main/java/net/minecraft/core/entity/animal/EntityAnimal.java
index 40b47b3a2..44c454c83 100644
--- a/src/main/java/net/minecraft/core/entity/animal/EntityAnimal.java
+++ b/src/main/java/net/minecraft/core/entity/animal/EntityAnimal.java
@@ -26,9 +26,9 @@ public abstract class EntityAnimal extends EntityPathfinder
     @Override
 	public int getMaxSpawnedInChunk()
     {
-        if(world.seasonManager.getCurrentSeason() == Seasons.OVERWORLD_SPRING)
+        if(world.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SPRING)
             return 8;
-        if(world.seasonManager.getCurrentSeason() == Seasons.OVERWORLD_WINTER)
+        if(world.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER)
             return 1;
         return 4;
     }
diff --git a/src/main/java/net/minecraft/core/entity/monster/EntityMonster.java b/src/main/java/net/minecraft/core/entity/monster/EntityMonster.java
index c30d5a610..2b6ba2314 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntityMonster.java
+++ b/src/main/java/net/minecraft/core/entity/monster/EntityMonster.java
@@ -89,9 +89,9 @@ public abstract class EntityMonster extends EntityPathfinder
     @Override
 	public int getMaxSpawnedInChunk()
     {
-        if(world.seasonManager.getCurrentSeason()== Seasons.OVERWORLD_SPRING)
+        if(world.getSeasonManager().getCurrentSeason()== Seasons.OVERWORLD_SPRING)
             return 2;
-        if(world.seasonManager.getCurrentSeason()== Seasons.OVERWORLD_WINTER)
+        if(world.getSeasonManager().getCurrentSeason()== Seasons.OVERWORLD_WINTER)
             return 8;
         return 4;
     }
diff --git a/src/main/java/net/minecraft/core/entity/monster/EntitySnowman.java b/src/main/java/net/minecraft/core/entity/monster/EntitySnowman.java
index e525b393e..5d7bbb07c 100644
--- a/src/main/java/net/minecraft/core/entity/monster/EntitySnowman.java
+++ b/src/main/java/net/minecraft/core/entity/monster/EntitySnowman.java
@@ -84,7 +84,7 @@ public class EntitySnowman extends EntityMonster
         int z = (int) this.z;
         Biome biome = world.getBlockBiome(x, y, z);
 
-        return super.getCanSpawnHere() && (world.canBlockSeeTheSky(x, y, z) && ((biome == Biomes.OVERWORLD_GLACIER) || ((world.seasonManager.getCurrentSeason() == Seasons.OVERWORLD_WINTER || world.seasonManager.getCurrentSeason() == Seasons.OVERWORLD_WINTER_ENDLESS) && (world.getCurrentWeather() == Weather.overworldSnow || world.getCurrentWeather() == Weather.overworldWinterSnow))));
+        return super.getCanSpawnHere() && (world.canBlockSeeTheSky(x, y, z) && ((biome == Biomes.OVERWORLD_GLACIER) || ((world.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER || world.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER_ENDLESS) && (world.getCurrentWeather() == Weather.overworldSnow || world.getCurrentWeather() == Weather.overworldWinterSnow))));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java b/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java
index ee9b0542c..a4efec458 100644
--- a/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java
+++ b/src/main/java/net/minecraft/core/entity/player/EntityPlayer.java
@@ -37,6 +37,7 @@ import net.minecraft.core.enums.EnumSleepStatus;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.tool.ItemToolSword;
+import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.player.inventory.Container;
@@ -128,6 +129,9 @@ public abstract class EntityPlayer extends EntityLiving
     @Override
 	public void tick()
     {
+        xdO = xd;
+        ydO = yd;
+        zd0 = zd;
         setupDwarfMode();
 
         if(isPlayerSleeping())
@@ -164,40 +168,6 @@ public abstract class EntityPlayer extends EntityLiving
             closeScreen();
             craftingInventory = inventorySlots;
         }
-        field_20066_r = field_20063_u;
-        field_20065_s = field_20062_v;
-        field_20064_t = field_20061_w;
-        double d = x - field_20063_u;
-        double d1 = y - field_20062_v;
-        double d2 = z - field_20061_w;
-        double d3 = 10D;
-        if(d > d3)
-        {
-            field_20066_r = field_20063_u = x;
-        }
-        if(d2 > d3)
-        {
-            field_20064_t = field_20061_w = z;
-        }
-        if(d1 > d3)
-        {
-            field_20065_s = field_20062_v = y;
-        }
-        if(d < -d3)
-        {
-            field_20066_r = field_20063_u = x;
-        }
-        if(d2 < -d3)
-        {
-            field_20064_t = field_20061_w = z;
-        }
-        if(d1 < -d3)
-        {
-            field_20065_s = field_20062_v = y;
-        }
-        field_20063_u += d * 0.25D;
-        field_20061_w += d2 * 0.25D;
-        field_20062_v += d1 * 0.25D;
         addStat(StatList.minutesPlayedStat, 1);
         if(vehicle == null)
         {
@@ -881,18 +851,18 @@ public abstract class EntityPlayer extends EntityLiving
             }
             if(bedChunkCoordinates == null || !bedChunkCoordinates.equals(x, y, z)) {
                 if(playerSpawnCoordinate == null || !playerSpawnCoordinate.equals(x, y, z)) {
-                    addChatMessage("bed.setSpawn");
+                    sendTranslatedChatMessage("bed.setSpawn");
                     setPlayerSpawnCoordinate(new ChunkCoordinates(x, y, z));
                 }
             }
             if (!world.getGameRule(GameRules.ALLOW_SLEEPING))
             {
-                addChatMessage("bed.noAllowSleeping");
+				sendStatusMessage(I18n.getInstance().translateKey("bed.noAllowSleeping"));
                 return EnumSleepStatus.DISABLED_BY_GAMERULE;
             }
 
             if(world.isDaytime() && world.getCurrentWeather() != Weather.overworldStorm) {
-            	addChatMessage("bed.noSleep");
+            	sendStatusMessage(I18n.getInstance().translateKey("bed.noSleep"));
                 return EnumSleepStatus.NOT_POSSIBLE_NOW;
             }
         }
@@ -1048,9 +1018,22 @@ public abstract class EntityPlayer extends EntityLiving
         return sleepTimer;
     }
 
-    public void addChatMessage(String s)
-    {
+    /**
+     * Translate the string and send it to this player
+     */
+    public void sendTranslatedChatMessage(String message) {
+    	sendMessage(I18n.getInstance().translateKey(message));
     }
+    
+    /**
+     * Send a string to this player, displayed in chat
+     */
+    public abstract void sendMessage(String message);
+    
+    /**
+     * Send a string to this player, displayed above the hotbar
+     */
+    public abstract void sendStatusMessage(String message);
 
     @Override
     public ItemStack getHeldItem()
@@ -1400,12 +1383,9 @@ public abstract class EntityPlayer extends EntityLiving
     public int swingProgressInt;
     public String username;
     public int dimension;
-    public double field_20066_r;
-    public double field_20065_s;
-    public double field_20064_t;
-    public double field_20063_u;
-    public double field_20062_v;
-    public double field_20061_w;
+    public double xdO;
+    public double ydO;
+    public double zd0;
     protected boolean sleeping;
     public ChunkCoordinates bedChunkCoordinates;
     private int sleepTimer;
@@ -1429,6 +1409,8 @@ public abstract class EntityPlayer extends EntityLiving
     protected float baseSpeed = 0.1f;
     protected float baseFlySpeed = 0.02f;
     protected boolean isDwarf = false;
+    public int lastRenderTick = 0;
+    public float wobbleTimer = 0;
     public static class SortByUsername implements Comparator<EntityPlayer> {
 
         @Override
